<template>
  <div class="main-content abnormal">
    <DetailHead result="严重违法企业名录：受理审批" />

    <div class="content-body">
      <el-form ref="form" :model="form" label-width="150px" label-position="right" :rules="formRules">
        <div class="form">
          <div class="tab">
            <div class="tab-title"><label>严重严重违法主体信息</label></div>
          </div>
          <div class="form-body">
            <el-row class="p0">
              <el-form-item label="移出主体信息">
                <!-- <el-button type="primary" size="mini" @click="showEntbaseList">查看主体名单<i class="el-icon el-icon-s-order" style="margin-left:5px" /></el-button> -->
                <label>统一社会信用代码/注册号：</label><span>{{ dissentModel.regNO }}</span><br>
                <label>企业名称：</label><span>{{ dissentModel.entName }}</span><br>
                <label>法人：</label><span>{{ dissentModel.leRepName }}</span>
              </el-form-item>
            </el-row>
            <el-row>
              <el-form-item label="移出违法失信企业名单的证据材料" class="upload padding0 bt0">
                <el-row>
                  <el-col :span="4" style="padding:0 10px">一、必备证据材料<span style="color:red">*</span></el-col>
                  <el-col :span="20" class="border-left" style="padding:0 10px">
                    1、国家企业信用信息公示系统上企业的历年年报记录截图<br>2、《严重违法失信企业信用修复申请表》扫描件<br>3、《严重违法失信企业信用修复审批表》扫描件
                  </el-col>
                </el-row>
                <el-row class="border-top">
                  <el-col :span="4" style="padding:0 10px">二、补充证据材料<span style="color:red">*</span></el-col>
                  <el-col :span="20" class="border-left" style="padding:0 10px">
                    <el-upload
                      ref="fileUpload"
                      class="upload-disabled"
                      :action="uploadPath"
                      :data="{bizseq:bizseq}"
                      :on-remove="removeFile"
                      :on-success="uploadCallback"
                      :on-preview="previewFile"
                      multiple
                      :file-list="fileList"
                      :disabled="true"
                      style="max-width:600px"
                    />
                  </el-col>
                </el-row>
              </el-form-item>
            </el-row>

          </div>
        </div>
        <div class="form">
          <div class="tab">
            <div class="tab-title"><label>处理意见</label></div>
          </div>
          <div class="form-body history">
            <div v-if="historyLog.length == 0" class="none">暂无历史意见</div>
            <el-steps direction="vertical">
              <el-step v-for="(each,index) in historyLog" :key="'historyLog'+index" :title="each.step + '：' + each.handler + ' 处办日期：' + each.handledate" :description="each.opinioncontent" status="finish" />
            </el-steps>
          </div>
        </div>
      </el-form>
      <div class="submit-box">
        <el-button @click="$router.back()">返回</el-button>
      </div>
    </div>
    <HandleDialog
      :show.sync="showEntbase"
      title="严重违法企业名单"
      style="width:50vw"
      @close="showEntbase = false"
    >
      <el-table
        :data="entbase"
        tooltip-effect="dark"
        style="width: 1200px"
        :fit="true"
        height="500px"
        :header-cell-style="{background:'#8cc3fb',color:'#fff'}"
        :row-class-name="tableRowClassName"
      >
        <el-table-column prop="regNO" label="统一社会信用代码/注册号" min-width="150" align="left" show-overflow-tooltip />
        <el-table-column prop="entName" label="名称" min-width="150" align="left" show-overflow-tooltip />
        <el-table-column prop="leRepName" label="法定代表人" align="left" show-overflow-tooltip />
      </el-table>
    </HandleDialog>
  </div>
</template>

<script>
import DetailHead from '@/components/DetailHead'
import HandleDialog from '@/components/HandleDialog'
import { removeAttachementById, listAttachmentByBizseq } from '@/api/attachment'
import { illegalDissNext, startIllegalDissent } from '@/api/illegal'
import { getUsersWithPermission } from '@/api/user'
import { taskOpinion } from '@/api/task'
import { getConstant } from '@/api/system'
import { isMenHu } from '@/utils/utils'

export default {
  components: {
    DetailHead,
    HandleDialog: HandleDialog
  },
  data() {
    return {
      bizseq: '',
      workflowId: '',
      uploadPath: `${process.env.VUE_APP_BASE_API}/attachment/uploadAdvance`,
      showEntbase: false,
      batchId: this.$route.query.batch,
      entbase: [],
      // 分页数据,这里用来保存每页切割后的数据
      // 看起来格式是这样的[[{},{},{}],[{},{},{}]]
      // 数组内套数组，每个数组就是一页数据
      totalPageData: [],
      // 共几页
      pageNum: '',
      // 每页显示数量
      pageSize: 10,
      // 当前显示页码
      currentPage: 1,
      // 总共多少条数据
      total: 1,
      // 当前要显示的数据
      dataShow: [],
      form: {
        enterType: 'company',
        nextNodeID: 'approveDissent',
        reason: '',
        opinion: ''
      },
      formRules: {
        reason: [
          { required: true, message: '请输入列入原因', trigger: 'blur' }
        ],
        opinion: [
          { required: true, message: '请输入经办意见', trigger: ['blur', 'change'] }
        ],
        reviewerId: [
          { required: true, message: '请选择审核人' }
        ]
      },
      reason: '',
      opinion: '',
      reasonOptions: [],
      opinionOptions: [{
        value: 0,
        label: '拟同意'
      }, {
        value: 1,
        label: '同意'
      }, {
        value: 2,
        label: '不同意'
      }],
      historyLog: [],
      exmainerOptions: [],
      fileList: [],
      user: JSON.parse(sessionStorage.getItem('user')),
      reviewer: [],
      submitLoading: false,
      currentNode: '', // 当前节点
      currentNodeName: '', // 当前节点名称
      dissentModel: {} // 异议主体信息
    }
  },
  watch: {
    // 原因渲染
    reason() {
      this.form.specause = this.reason
      let name = ''
      this.reasonOptions.forEach(each => {
        if (this.reason === each.value) {
          name = each.label
        }
      })
      this.form.reason = name
    },
    // 意见渲染
    opinion() {
      let name = ''
      this.opinionOptions.forEach(each => {
        if (this.opinion === each.value) {
          name = each.label
        }
      })
      this.form.opinion = name
    }
  },
  mounted() {
    this.bizseq = this.$route.query.bizseq
    this.workflowId = this.$route.query.workflowId
    this.tasklistid = this.$route.query.tasklistid

    // 加载常用语
    this.opinionOptions = this.$util.getCommonWords(this.user.primaryKey)
    // 加载异议申请信息
    startIllegalDissent({ tasklistid: this.tasklistid }).then(res => {
      if (res.code === 0) {
        // 添加分页index
        const i = 1
        const data = res.data
        this.dissentModel = data.tsBizDissentModel
      } else {
        this.$message.error('加载异议信息失败')
      }
    })

    // 加载处办记录
    taskOpinion(this.workflowId).then(res => {
      if (res.code === 0) {
        res.data.forEach(each => {
          switch (each.opiniontype) {
            case '0': each.step = '经办人'; break
            case '1': each.step = '审核人'; break
            case '2': each.step = '审批人'; break
          }
          this.historyLog.push(each)
        })
      } else {
        this.$message.error('加载处办记录失败')
      }
    })
    // 加载企业列入原因
    getConstant('CD73').then(res => {
      if (res.code === 0) {
        const list = []
        res.data.forEach(each => {
          list.push({
            value: each.code,
            label: each.name
          })
        })
        this.reasonOptions = list

        if (this.$util.isNotEmpty(this.reason)) {
          let name = ''
          this.reasonOptions.forEach(each => {
            if (this.reason === each.value) {
              name = each.label
            }
          })
          this.form.reason = name
        }
      }
    })

    // 加载审核人
    this.loadReviewer()

    // 加载附件清单
    listAttachmentByBizseq(this.bizseq).then(data => {
      data.forEach(each => {
        each.id = each.attachmentid
        each.name = each.filename
        each.url = `${process.env.VUE_APP_DOWNLOAD_URL}/` + each.temppath
      })
      this.fileList = data
    })
  },
  methods: {
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 === 1) {
        return 'warning-row'
      }
    },
    // 上传文件预览
    previewFile(file) {
      window.open(file.url, '_blank')
    },
    // 发送提交
    submitForm() {
      this.$refs.form.validate(valid => {
        if (!valid) return
        this.$confirm('是否确认提交？', '提示').then(() => {
          this.form.bizseq = this.bizseq
          this.form.workflowid = this.workflowId
          this.form.opiniontype = '1'
          this.form.handler = this.user.username
          this.form.handlerid = this.user.primaryKey
          this.form.opinioncontent = this.form.opinion
          this.form.tasklistid = this.tasklistid
          if (this.form.nextNodeID == 'acceptDissentEnter') {
            this.form.nextPerformerids = this.historyLog[this.historyLog.length - 1].handlerid
            this.form.nextPerformerNames = this.historyLog[this.historyLog.length - 1].handler
          } else {
            this.form.nextPerformerids = this.form.reviewerId
            for (const i in this.reviewer) {
              if (this.reviewer[i].primaryKey === this.form.reviewerId) {
                this.form.nextPerformerNames = this.reviewer[i].name
              }
            }
          }
          for (const key in this.dissentModel) {
            if (this.form[key] || key == 'lauptime' || !this.dissentModel[key]) continue
            this.form[key] = this.dissentModel[key]
          }
          this.submitLoading = true
          illegalDissNext(this.form).then(res => {
            this.submitLoading = false
            if (res.code === 0) {
              this.$message.success('审批成功')
              if (isMenHu()) {
                // 信创门户环境跳转回待办
                window.location.href = '/aiccs/#/todo/list'
              } else {
                this.$router.back()
              }
            }
          })
        }).catch(() => {})
      })
    },
    uploadCallback(res, file, fileList) {
      if (res.code === 0) {
        file.id = res.data.attachmentid
        file.url = `${process.env.VUE_APP_DOWNLOAD_URL}/` + res.data.temppath
        this.fileList = fileList
      }
    },
    // 查看严重违法主体名单
    showEntbaseList() {
      this.showEntbase = true
    },
    // 移除文件回调
    removeFile(file, fileList) {
      removeAttachementById(file.id).then(res => {
        if (res.code === 0) {
          this.$message.success('删除成功')
        } else {
          this.$message.error(res.msg)
        }
      })
    },
    // 加载审核人
    loadReviewer() {
      getUsersWithPermission('approveSerIllegal', this.user.orgId).then(res => {
        if (res.code === 0) {
          this.reviewer = res.data
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
  .main-content{
    padding: 10pt;
    .back-btn{
      position:absolute;
      right:40pt;
    }
    .content-header,.content-body{
      background: white;
      padding:20PX 10PX;
      border:1PX solid #eee;
    }
    .content-header{
      height:60PX;
      display: flex;
      align-items: center;
      .title{
        font-weight: 700;
        font-size: $font-size-sub-title;
      }
    }
    .content-body{
      padding:20pt;
      .tab{
        .tab-title{
          label{
            display:inline-block;
          }
        }
      }
      .form{
        margin-bottom: 20pt;
      }
    }
  }
  .el-row  {
    border-left:1px solid $color-border;
  }
  .bt0{
   /deep/.el-form-item__label{
      border-top: 0!important;
    }
  /deep/.el-form-item__content{
      border-top: 0!important;
  }
}
</style>
<style lang="scss">
  .main-content.abnormal{
    font-size: $table-content-font-size;
    .el-form-item{
      margin-bottom:0;
      background: $color-form-label;
      .el-form-item__label{
        font-size: $table-content-font-size;
        padding-left: 10px;
        border-top: 1px solid $color-border;
        /* border-left: 1px solid $color-border; */
      }
      .el-form-item__content{
        background: white;
        padding: 10px;
        font-size: $table-content-font-size;
        border-top: 1px solid $color-border;
        border-right: 1px solid $color-border;
        border-left: 1px solid $color-border;
        .border-left{
          border-left: 1px solid $color-border;
        }
        .border-top{
          border-top: 1px solid $color-border;
        }
      }
    }
    .padding0{
      .el-form-item__content{
        padding: 0;
        border-left: 0;
      }
    }
    .el-form-item:last-child{
      border-bottom: 1px solid $color-border;
    }
    .form-body.history{
      padding:15px;
      border:1px solid $color-border;
    }
    .el-form-item.is-error .custom .el-input__inner{
      border-color:$color-border;
    }
    .el-textarea.is-disabled .el-textarea__inner{
      color: #1c1e23;
    }
  }
</style>
